//     DS18B20

//  crc
void read_crc(void);
char DLcrc8 (char *pData,char counterBytes );
char Check_Valid_Key(void);

//
void reset()
{
   restart_wdt();
   set_trism_A(0x00);
   output_low(DS);
   delay_us(500);
   set_trism_A(0xff); //   output_1w
   //    
   delay_us(55);
   
   //    
   delay_ms(1);
}

//   DS18B20
void command_1w(int comm)
{
   int n;
   restart_wdt();
   //    
   for(n=0;n<8;n++)
   {
      output_low(DS);
      if(comm&0x01)
          output_high(DS);
      delay_us(60);
      set_trism_A(0xff);
      // 
      comm>>=1;
   }
}

// 
int read_1w()
{
   int n,temp;
   temp=0;
   restart_wdt();
   for(n=0;n<8;n++)
   {
      temp>>=1;
      output_low(DS);
      set_trism_A(0xff);
      if(input(DS))
         temp|=0x80;
      delay_us(60);
      
   }
   return temp;
}


void init_temp()
{  
   reset();
   //  ,    , =00 
   //9  , 100 
   command_1w(0xcc);
   command_1w(0x4e);//    
   command_1w(0x00);
   command_1w(0x00);
   command_1w(0x00);
   set_trism_A(0xff);
}
 
 
 //       
 void read_temp()
 {
   int temp,MS_byte,LS_byte;
   
   reset();
  // crc, , ,    
  ptr_ds18b20->crc=Check_Valid_Key();
  
      reset();
     command_1w(0xcc);
     //command_1w(0xcc);//    
      command_1w(0xbe); // ,   
      LS_byte=read_1w();
      MS_byte=read_1w();
   
   //---------------------------------------------
   //     ,   
   //LS_byte&=0xf0;
   //LS_byte>>=4;
   LS_byte>>=1;
   LS_byte&=0x7f;
   //LS_byte&=0x0f;
   
   //temp=MS_byte;
   //MS_byte&=0x0f; //0x07=0000 0111
   //MS_byte<<=4;
   
   restart_wdt();
   if(MS_byte/*temp&0xf0*/)
   {
      temp=0x01; // 
      LS_byte=LS_byte/*|MS_byte*/;
      //LS_byte=(~LS_byte)+1;
   }
   else
   {
      temp=0;    // 
      LS_byte=LS_byte/*|MS_byte*/;
   }
   
   //       
  
      ptr_ds18b20->data=LS_byte;
      ptr_ds18b20->znak=temp;
     //     1820
     reset();
     command_1w(0xcc);
     command_1w(0x44);
 }
 

//    , crc
void read_crc()                  
{
   char i;
   reset();
    command_1w(0xcc);
    command_1w(0xbe); // ,   
   for(i=0;i<9;i++)
   {
      OW_BUF[i]=read_1w(); //     
    }  
} 

char DLcrc8 (char *pData,char counterBytes )
 { 
     char  crc;
     char  data;
     char i,fb;

     crc =0;                        // 
   do                                       //   
    { 
       data = *pData++;                     //  
       for (i=0;i<8;i++)               //    
        {
            fb =crc  ^ data;                  // ,     
            fb&=1;                        // 100110001,   100011001,   
            crc >>= 1;                       //    
            data >>=1;
            if (fb == 1)crc^=0x8c;// ,  1000 1100
        }
    }
   while (counterBytes-- );
   return crc;
 }
 

char Check_Valid_Key(void)
{
   unsigned char CRC;
   CRC=0;
   read_crc();                     //  
   CRC=DLcrc8(OW_BUF,7);         //   
   if(CRC==OW_BUF[8]) 
      return(1);   //       
   return(0);
}
